
c usage e.g.: cc_sed 2xPI  ___
c                    0100  c__
c                    1000  cs_
c                    5000  csw
c                          _s_
c#ifdef sgi
c#include <fsigfpe.h>
c#endif
C----------------------------------------------------------------------
      INCLUDE 'parameter.include'
      INCLUDE 'parameter.sediment.include'
      INCLUDE 'common.horvel'
      INCLUDE 'common.wathic'
      INCLUDE 'common.chemis'
      INCLUDE 'common.biocon'
      INCLUDE 'common.topogr'
      INCLUDE 'common.production'
      INCLUDE 'common.thermo'
      INCLUDE 'common.ctrac'
      INCLUDE 'common.divers'
      INCLUDE 'common.caco3c'   
      INCLUDE 'common.seddiag'
      include 'common.sediment'
      include 'common.hg'
      include 'hg.inc'

c      include 'common.archer'

c      REAL calgg_old(ip_sedmain_max,nz_sedmain_max)
c      REAL buried_mass_old(ip_sedmain_max,i_bur_rec_max),
c     *      buried_calfrac_old(ip_sedmain_max,i_bur_rec_max)

      character*6 yearname
      character*25 filename
      integer slugco2, co2spin

      INCLUDE 'equivalence.include'
      logical rstart
      DATA uff/2*0.,30*1100.,900.,700.,500.,300.,100.,50.,100.,300.,
     .           500.,700.,900.,30*1100.,3*0./

C!!!!      DATA td,xx,xb,dla,dlro,dlru/576*0./
      DATA td,xx,xb,dla,dlro,dlru/608*0./
C***deactivate
c 90/05/14 begin
C     DATA corrfa/12*1.0/
C     DATA corrf1/12*1.0/
C***deactivated 90/05/14 END
C***deactivated 90/05/14 begin
C     DATA deptp/5472*0./
C     DATA intw/0,11250,20000,35000,57500,85000,
C    ,150000,250000,350000,450000,600000/4
C     DATA w/54720*0.,5472*0./
C     DATA intu/7500,15000,25000,45000,70000,
C    ,100000,200000,300000,400000,500000,700000/
C     DATA pengbi/0.,2.5,5.,8.5,12.5,17.,20.,21.,21.5,21.5,21.5,
C    121.,19.,17.,17.,15.,17.,14.,11.,8.,5.,2.,7.,7./
C     DATA bombat/130*0.,11*20.,40.,70.,95.,75.,68.,63.,57.,55.,
C    152.,50.,47.,44.,42.,40.,38.,36.,34.,32.,30./
C     DATA scrit/12*1.e-8/
C     DATA scrit/12*1.e-20/
C     DATA uff/2*0.,30*1100.,900.,700.,500.,300.,100.,2*50.,100.,300.,
C    1500.,700.,900.,30*1100.,2*0./
C     DATA uff/32*1100.,900.,700.,500.,300.,100.,2*50.,100.,300.,
C    1  500.,700.,900.,32*1100./
C***deactivated 90/05/14 END
      namelist /tune/ intstp,timax
      DATA intstp/3/
      DATA timax/1200./

C     -----------------------------------------------------------------
C*         x. initial setting of arrays
C             ------- ------- -- ------

C!!!!
c#ifdef sgi
c      isig = 0 +
c     .         fpe_en_underfl +
c     .         fpe_en_overfl  +
c     .         fpe_en_divzero +
c     .         fpe_en_invalid

c      CALL handle_sigfpes(fpe_on, isig,i,fpe_abort_on_error,i)      
c#endif

      n_output_rotation = 1

      DO 15 j=1,je
      DO 15 i=1,ie
        deptp(i,j)=0.
   15 CONTINUE
      DO 16 k=1,kep
      DO 16 j=1,je
      DO 16 i=1,ie
        w(i,j,k)=0.
   16 CONTINUE
      DO 10 n=1,nv
        scrit(n)=3.e-7
   10 CONTINUE
      scrit(7:10) = 1.d-17
c      scrit(11:12) = 1.d-5
C!!!!
c      scrit( 1)=1.e-10
c      scrit( 2)=1.e-10
C      scrit(10)=1.e-11
C     DO 11 j=1,72
C       WRITE(6,'(''uff('',i2,'')='',f7.1)')j,uff(j)
C  11 CONTINUE
      DO 17 j=1,je
      DO 17 m=1,3
        td(j,m)=0.
   17 CONTINUE
      DO 18 j=1,je
        xx(je)=0.
        xb(je)=0.
        dla(je)=0.
        dlro(je)=0.
        dlru(je)=0.
   18 CONTINUE
C***deactivated 90/05/14 begin
C     DO 19 n=1,nv
C       corrfa(n)=1.
C       corrf1(n)=1.
C  19 CONTINUE
C***deactivated 90/05/14 END
C***newmod END

C     -----------------------------------------------------------------
C*         x. OPEN files
C             ---- -----

        OPEN(17,file='MONITO',status='unknown',
     .         access='sequential',form='formatted')
        OPEN(19,file='PROFIL',status='unknown',
     .         access='sequential',form='formatted')
        OPEN(36,file='DPHILA',status='unknown',
     .         access='sequential',form='formatted')
c        OPEN(38,file='VELOCI',status='unknown',
c     .         access='sequential',form='unformatted')
c        OPEN(42,file='VELOCI.archer',status='unknown',
        OPEN(38,file='VELOCI.heinze',status='unknown',
     .         access='sequential',form='unformatted')
        OPEN(43,file='INDLIS',status='unknown',
     .         access='sequential',form='formatted')
        OPEN(83,file='RESTART',status='unknown',
     .         access='sequential',form='unformatted')
        OPEN(87,file='RESULT',status='unknown',
     .         access='sequential',form='unformatted')
        OPEN(97,file='CC.INTERMED.A',status='unknown',
     .         access='sequential',form='unformatted')
        OPEN(98,file='CC.INTERMED.B',status='unknown',
     .         access='sequential',form='unformatted')
        OPEN(99,file='PRINTOUT',status='unknown',
     .         access='sequential',form='unformatted')

c#ifdef sgi
c      READ(5,nml=tune)
c#else
c      READ(5,tune)
c#endif
      print*,'***tune READ '
      print*,'***tune   intstp=',intstp,' timax=',timax
C     STOP 'test'
C***deactivated 90/05/14 begin
C       OPEN(71,file='HORMAL',status='unknown',
C    *       access='sequential',form='formatted')
C       OPEN(72,file='VERMAL',status='unknown',
C    *       access='sequential',form='formatted')
C       OPEN(74,file='DEEPR7',status='unknown',
C    *       access='sequential',form='formatted')
C       OPEN(39,file='REACON',status='unknown',
C    *       access='sequential',form='formatted')
C***deactivated 90/05/14 END
C***deactivated 90/05/14 begin

C     -----------------------------------------------------------------
C*         1. initiate total atmospheric input from anthropogenic
C*            sources
C             -------- ----- ----------- ----- ---- -------------

C     totin=0.
C***deactivated 90/05/14 END

C     -----------------------------------------------------------------
C*         3. initiate julian year
C             -------- ------ ----

C      annu=-2000.
       annu=-10000.

C     -----------------------------------------------------------------
C*         x. set initial value of total time steps for ultimate
C             start (no restart)
C             ----- --- ---------- ----- ---- ----- --- --------
      nyetot=0

C     -----------------------------------------------------------------
C*         6. set number of timesteps to be integrated
C             --- ------ -- --------- -- -- ----------

C     intstp=3   --> namelist tune
      intstp = 1900

C     -----------------------------------------------------------------
C*         6. set max. cpu time in seconds that can be used by the run
C             --- ---- --- ---- -- ------- ---- --- -- ---- -- --- ---

C     timax=1200.   --> namelist tune
      timax = 2200.

C     -----------------------------------------------------------------
C*         4. initiation of horizontal velocities, geometric, chemical,
C             and biological variables
C             --- ---------- --------- ----------- ---------- ---------

      CALL initia1
      print*,' initia1 finished'
      CALL initia2
      print*,' initia2 finished'

C     -----------------------------------------------------------------
C*         5. set layer thickness (with respect to w-points)
C             --- ----- --------- ----- ------- -- ---------

C***oldmod begin
C     dzw(1)=11250.
C     dzw(2)=8750.
C     dzw(3)=15000.
C     dzw(4)=22500.
C     dzw(5)=27500.
C     dzw(6)=65000.
C     dzw(7)=100000.
C     dzw(8)=100000.
C     dzw(9)=100000.
C     dzw(10)=150000.
C***oldmod END
C***newmod begin

C  s e e subr. r e a c i r

C     DO 1 k=1,ke
C       dzw(k)=intw(k+1)-intw(k)
C       print*,'***dzw(',k,')=',dzw(k)
C   1 CONTINUE
C***newmod END

C     -----------------------------------------------------------------
C          7. calculate vertical component of velocity from
C             horizontal components (continuity of volume)
C             ---------- ---------- ----------- -- --------

      DO 7917 k=1,ke
      DO 7917 j=jl1,jle
      DO 7917 i=1,ie
      il=i-1
      IF(il.le.0) il=ie
      w(i,j,k+1)=w(i,j,k)+dli(j)*(u(i,j,k)*ddu(i,j,k)
     .  -u(il,j,k)*ddu(il,j,k)+dpin*(ddu(il,j-1,k)*v(il,j-1,k)*dla(j-1)
     .  -ddu(i,j+1,k)*v(i,j+1,k)*dla(j+1))  )
7917  CONTINUE
      DO 4782 k=1,ke
      DO 4782 j=jl1,jle
      DO 4782 i=1,ie
      w(i,j,k)=w(i,j,k)-w(i,j,kep)
4782  CONTINUE
      DO 4783 j=1,je
      DO 4783 i=1,ie
      w(i,j,kep)=zero
      w(i,j,1)=zero
4783  CONTINUE
      DO 4003 j=1,je
      DO 4003 i=1,ie
      DO 4003 k=2,ke
        IF(ddz(i,j,k).LT.1.)w(i,j,k)=0.
 4003 CONTINUE

C     -----------------------------------------------------------------
C*         8. READ atm. and oc. inventories and concentrations
C             for re-start of program
C             --- -------- -- ------------- --- --------------

      rstart =.false.
      IF(rstart)
     .    READ(83)n_year_first,nyetot,atqqq,
     $     c12inv,c13inv,c14inv,phoinv,alkinv,
     .     atc,chemv,ca,cn,prorca,
     *     calgg,buried_mass,buried_calfrac
        do k=1,ke
        do i=1,ie
        do j=1,je
          ca(i,j,k,5)=sco212(i,j,k)
          ca(i,j,k,6)=sco212(i,j,k)
          cn(i,j,k,5)=sco212(i,j,k)
          cn(i,j,k,6)=sco212(i,j,k)
        enddo
        enddo
        enddo
        n_year_first = 0
        n_year_last = 12220
        ispinup = 20000

c        ispinup = 0

        WRITE(6,*) "beginning in year ", n_year_first

c        write(84,*)nyearstart,nyetot,atqqq,
c     $     c12inv,c13inv,c14inv,phoinv,alkinv,
c     .     atc,chemv,ca,cn,prorca,
c     *     calgg,buried_mass,buried_calfrac

c        DO 2001 i = 1, i_parallel
c           DO 2001 k = 2, kmax
c              calgg(k,i) = calgg_old(i,k)
c 2001   CONTINUE
c        DO 2002 i = 1, i_parallel
c           DO 2002 k = 1, i_bur_rec_max
c              buried_mass(k,i) = buried_mass_old(i,k)
c              buried_calfrac(k,i) = buried_calfrac_old(i,k)
c 2002   CONTINUE

c        WRITE(87)n_year_first,nyetot,atqqq,
c     $     c12inv,c13inv,c14inv,phoinv,alkinv,
c     .     atc,chemv,ca,cn,prorca,
c     *     calgg,buried_mass,buried_calfrac

c        pause

c      DO 8406 k=1, ke
c         DO 8406 j=1, je
c            DO 8406 i=1, ie
c               ca(i,j,k,2) = ca(i,j,k,2) + 75E-6
c 8406 CONTINUE
                   
      sumfl=0.
      sumco=0.
      DO 8407 k=1,ke
      DO 8407 j=jl1,jle
      DO 8407 i=1,ie
c      sumco=sumco+dzdl(i,j,k)*(sco214(i,j,k)+calc14(i,j,k)+
c     .  poc14(i,j,k))
8407  CONTINUE
      DO 8408 j=jl1,jle
      DO 8408 i=1,ie
      sumco=sumco+atc(i,j,3)*dlll(i,j)*0.033
      sumfl=sumfl+dlll(i,j)
8408  CONTINUE
      DO 8409 j=jl1,jle
      DO 8409 i=1,ie
c      sumco=sumco+ccsd14(i,j)*dlll(i,j)
c      sumco=sumco+ocsd14(i,j)*dlll(i,j)
8409  CONTINUE
      prc14=deccon*sumco/(sumfl*0.033)
      prc14t=dt*prc14
C new 14c production initiation END
C     print*,'vor inibil ***nyetot= ',nyetot

C     -----------------------------------------------------------------
C*         9. initiate inventories
C             -------- -----------

      CALL inibil

C     -----------------------------------------------------------------
C*         x. if ifulbi=1 CALL pools after every SUBROUTINE


      ifulbi=0

C     -----------------------------------------------------------------
C*        11. begin of time loop (years) (loop 1111)
C             ----- -- ---- ---- ------- -----------

      print*,'***begin of time loop***'

c      call pools

      DO 1111 nyear = n_year_first, n_year_last

         IF( MOD(nyear,1000) .EQ. 0 ) THEN
            CALL intermed(nyear,nyetot,n_output_rotation)
         ENDIF


C*        11.3 set actual julian year
      annu=annu+1.

C*        11.4 production and distribution of biogenic particulate
C              matter

      IF(ifulbi.EQ.1) THEN
         WRITE(6,*) "going into biology"
         CALL pools
      endif

      CALL biology

      IF(ifulbi.EQ.1) THEN
         WRITE(6,*) "coming out of biology"
         CALL pools
      endif


C*        11.6 surface chemistry and gas exchange ocean<->atmosphere
c      WRITE(6,*)'atm pco2 = ',atc12(1,31),atc12(1,5),atc12(1,65)
c      WRITE(6,*) 'year ',nyear

c      write(6,*) "Delta T = ", delta_t_target, delta_t

      call chemin1(delta_t)

      CALL surfch

      call advect

c      if(ifulbi) then
c         write(6,*) "coming out of advect", nyear
c         call pools
c      endif




C*        11.9 pco2 difference ocean surface layer/atmosphere [ppm]
      DO 1291 j=jl1,jle
      DO 1291 i=1,ie
      chemv(i,j,3)=rwat(i,j)
     .     *(chemv(i,j,3)-atqqq)
1291  CONTINUE

C*       11.22 calculate zonal averages of atmospheric pco2
      DO 81 iv=1,3
      DO 82 j=jl1,jle
      aav=zero
      DO 821 i=1,ie
      aav=aav+atc(i,j,iv)
821   CONTINUE
      aav=aav*zoanz

C*       11.23 meridional diffusion of co2 in the atmosphere
C              by solving tridiagonal matrix
C              xb: terms to convert tridiagonal matrix into
C                  upper triangle matrix
C              xx: new atmospheric concentrations gained
C                  directly from solving upper triangle matrix
      xb(j)=aav
82    CONTINUE
      jstart=jl1+1
      DO 84 j=jstart,jle
      xb(j)=xb(j)-td(j-1,1)*xb(j-1)
84    CONTINUE
      xx(jle)=xb(jle)/td(jle,2)
      je1=jle-1
      DO 85 j=jl1,je1
      k=(jle+jl1-1)-j
C     print*,'do 85 j k xb(k) td(k,3) xx(k+1) td(k,2)',
C    *              j,k,xb(k),td(k,3),xx(k+1),td(k,2)
      xx(k)=(xb(k)-td(k,3)*xx(k+1))/td(k,2)
85    CONTINUE
      DO 86 j=jl1,jle
      DO 86 i=1,ie
      atc(i,j,iv)=xx(j)
86    CONTINUE
      IF(iv.EQ.1) then
C     WRITE(6,6123)(xx(j),j=4,70,6)
      ENDIF
81    CONTINUE
8291  CONTINUE
C     WRITE(92,1931) nyear,annu,atqqq,totio
      isubr=9

      call hg_cycle(nyear)

      IF(ifulbi.EQ.1) THEN
         WRITE(6,*) "coming out of surfch "
         CALL pools
      endif

      IF(ifulbi.EQ.1)
     .  CALL pools

C*       12.14 14c decay

c*       12.14 14c decay
c
      decay=1.-deccon*dt
      sumfl=0.
      sumco=0.
      do 270 k=1,ke
      do 270 j=jl1,jle
      do 270 i=1,ie
c     sumco=sumco+dzdl(i,j,k)*(sco214(i,j,k)+calc14(i,j,k)+
c    1poc14(i,j,k))
      sumco=sumco+dzdl(i,j,k)*sco214(i,j,k)
270   continue
      do 271 j=jl1,jle
      do 271 i=1,ie
      sumco=sumco+atc(i,j,3)*dlll(i,j)*0.033
      sumfl=sumfl+dlll(i,j)
271   continue
      do 272 j=jl1,jle
      do 272 i=1,ie
c     sumco=sumco+ccsd14(i,j)*dlll(i,j)
c     sumco=sumco+ocsd14(i,j)*dlll(i,j)
272   continue
c
      do 1241 j=jl1,jle
      do 1241 i=1,ie
c     atc14(i,j)=(atc14(i,j)+prc14t)*decay
      atc14(i,j)=atc14(i,j)*decay
      atc14(i,j)=atc14(i,j)+prc14t
c     ccsd14(i,j)=ccsd14(i,j)*decay
c     ocsd14(i,j)=ocsd14(i,j)*decay
1241  continue
      do 1242 k=1,ke
      do 1242 j=jl1,jle
      do 1243 i=1,ie
      sco214(i,j,k)=sco214(i,j,k)*decay
c     poc14(i,j,k)=poc14(i,j,k)*decay
c     calc14(i,j,k)=calc14(i,j,k)*decay
1243  continue
1242  continue
c
      sumfl=0.
      sumco=0.
      do 370 k=1,ke
      do 370 j=jl1,jle
      do 370 i=1,ie
c     sumco=sumco+dzdl(i,j,k)*(sco214(i,j,k)+calc14(i,j,k)+
c    1poc14(i,j,k))
      sumco=sumco+dzdl(i,j,k)*sco214(i,j,k)
370   continue
      do 371 j=jl1,jle
      do 371 i=1,ie
      sumco=sumco+atc(i,j,3)*dlll(i,j)*0.033
      sumfl=sumfl+dlll(i,j)
371   continue
      do 372 j=jl1,jle
      do 372 i=1,ie
c     sumco=sumco+ccsd14(i,j)*dlll(i,j)
c     sumco=sumco+ocsd14(i,j)*dlll(i,j)
372   continue
c
C*       11.23a average special grid points (u. mik's fields)
C     CALL spemea

C*       11.24 CLOSE balances
c      isubr=7
c      IF(ifulbi.EQ.1)
c     .  CALL bilanz(isubr)
C***deactivated 90/05/14 begin
C      DO 99639 iv=1,nv
C      ca(i,j,k,iv)=ca(i,j,k,iv)*corrfa(iv)
C99639 CONTINUE
C***deactivated 90/05/14 begin

C*        11.25 count total number of time steps
c      nyetot=nyetot+1

C*       11.26 average atmospheric pco2 [ppm]
c      atqqq=0.5*atcq(1)*dphi/erdof
C     print*,'   atc   annu=',annu,' nyetot=',nyetot,
C    *'  mean atmospheric pco2 [ppm]= ',atqqq

C*    11.x  size of carbon pools
c      IF(ifulbi.EQ.1)

C     IF(ifulbi.NE.1.AND.MOD(nyetot,50).EQ.0)then
C       CALL pools
C       CALL avecon
C       CALL conmap
C     ENDIF


C     -----------------------------------------------------------------
C*        12. END of time loop
C             --- -- ---- ----
1111  CONTINUE
      print*,'***end of time loop***'

c      OPEN(108,file='porewaterdump',status='unknown',
c     .         access='sequential',form='unformatted')
c      write(108) pore, form, o2, carb, zrct, orgml, calml
c      close(108)


C     -----------------------------------------------------------------
C*        12a. calculate carbon pool sizes
C              --------- ------ ---- -----
c      CALL pools

C     -----------------------------------------------------------------
C*        13. final calculation of inventories
C             ----- ----------- -- -----------
      isubr=8
c      CALL bilanz(isubr,1,0)
c      CALL avecon
C     CALL conmap

C     -----------------------------------------------------------------
C*        10. rewind of output file for re-start values
C             ------ -- ------ ---- --- -------- ------

      rewind 87

C     -----------------------------------------------------------------
C*        14. WRITE all essential variables to output file for re-start
C             ----- --- --------- --------- -- ------ ---- --- --------
      print*,'vor WRITE(87) ***nyetot= ',nyetot
        WRITE(87)nyear,nyetot,atqqq,
     $     c12inv,c13inv,c14inv,phoinv,alkinv,
     .     atc,chemv,ca,cn,prorca,
     *     calgg,buried_mass,buried_calfrac


C*        17. print depth profiles at regions of interest
C             ------- ----- --- ------ ---- -------- ---- --------
C     CALL poipro

      CLOSE(17,status='keep')
      CLOSE(19,status='keep')
      CLOSE(36,status='keep')
      CLOSE(38,status='keep')
      CLOSE(43,status='keep')
      CLOSE(83,status='keep')
      CLOSE(87,status='keep')
c      CLOSE(88,status='keep')
C***deactivated 90/05/14 begin
C     CLOSE(71,status='keep')
C     CLOSE(72,status='keep')
C     CLOSE(37,status='keep')
C     CLOSE(74,status='keep')
C     CLOSE(39,status='keep')

      STOP
601   FORMAT(1x,12f6.0)
602   FORMAT(1x,12f6.3)
628   FORMAT(1x,6htranac,10f8.6)
671   FORMAT(1x,12f6.2)
6123  FORMAT(12f6.1)
      END


